<?php

$pageGuide = "";
$mode = 0;

//ini_set( 'error_reporting', E_ALL );	//デバッグ用

/*
	新着情報csv取得
	返り値：表示する新着情報配列
	別途ページガイドを生成
*/
function getcsv($page)	{
	global $csvname;
	global $mode;
	global $pageGuide;

	$fh = @fopen($csvname,'rb');
	$csv = array();
	if(!$fh)	{
		$pageGuide = "";
		return $csv;
	}
	setlocale(LC_ALL, 'ja_JP.UTF-8');
	while(($line = fgetcsv($fh,LINE_MAX,",")) !== FALSE) {
		if($line[DSP_FLG] != "" && $line[DSP_FLG] != "0")	{
			if($line[DSP_FLG] == "1")	{
				if($mode == 1)	{
					$csv[] = $line;
				}
				continue;
			} else if($line[DSP_FLG] == "2")	{	//2014-02-17 チェック先間違い修正
				continue;
			}
		}
		$csv[] = $line;
	}
	fclose($fh);
	
	$max = count($csv);
	if($page == 0)	{	//toppage ページ切り替えは無い
		$start = 0;
		$pageGuide = "";
		$end = PAGE_SIZE_TOP;
	} else	{
		$start = ($page - 1) * PAGE_SIZE;
		$pageGuide = getPageGuide($page,$max);
		$end = PAGE_SIZE;
	}
	if($max == 0)	{
		return $csv;
	}
	if($start > $max)	{
		$ret = "";
	} else	{
		$ret = array();
		$end = $start + $end;
		for($cnt = $start;$cnt < $end ;$cnt++ )	{
			if(isset($csv[$cnt]))	{	//2014-02-17 ndefined offset 対応
				if($csv[$cnt] != "")	{
					$ret[] = $csv[$cnt];
				}
			}
		}
	}
	return $ret;
}


/*
	ページガイドを作る
	返り値：ページガイド文字列
*/
function getPageGuide($page,$max)	{
	global $systemImgdir,$previewImgdir;
	global $systemPrg;
	global $mode;

	if($mode == 1)	{
		$imgdir = $previewImgdir;
	} else	{
		$imgdir = $systemImgdir;
	}
	if($page == 1)	{
		$prev = "<img src='".$imgdir."noprev.png'>";
	} else	{
		$prev = "<a href='javascript:whatsnew(".($page - 1).");'><img src='".$imgdir."prev.png'></a>";
	}
	if($max > 0)	{
		$pageMax = ceil($max / PAGE_SIZE);
	} else	{
		$pageMax = 1;
	}

	if($page == $pageMax)	{
		$next = "<img src='".$imgdir."nonext.png'>";
	} else	{
		$next = "<a href='javascript:whatsnew(".($page + 1).");'><img src='".$imgdir."next.png'></a>";
	}

	$pages = "";
	for($cnt = 1;$cnt <= $pageMax;$cnt++ )	{
		if($cnt == $page)	{
			$pages .= " ".$cnt." ";
		} else	{
			$pages .= " <a href='javascript:whatsnew(".$cnt.");'>$cnt</a> ";
		}
	}
	$guide = "\n<p id='pageGuide'>".$prev.$pages.$next."</p>\n";
	return $guide;
}

/*
	エラー
	これが呼ばれると強制終了
*/
function	errDsp($mes)	{
	global	$tmpl;

	$inc = $tmpl."/tmpl/err.htm";
	$dsptxt = file_get_contents($inc);
	$dsptxt = str_replace("<_#_MES_#_>",$mes,$dsptxt);
	echo $dsptxt;
	exit;
}


/*
	新着情報csv取得
	返り値：全新着情報配列
*/
function getcsvAll()	{
	global $csvname;
	global $mode;

	$fh = fopen($csvname,'rb');
	$csv = array();
	setlocale(LC_ALL, 'ja_JP.UTF-8');

	//2014-02-17 行の長さの設定が反映しないのに対処と、削除済みデータ関係の修正に対応
	while(($line = fgetcsv($fh,LINE_MAX,",")) !== FALSE) {
		if($line[DSP_FLG] == "2")	{
			continue;
		}
		$csv[] = $line;
	}
	fclose($fh);

	return $csv;
}


/*
	新着情報csv保存
*/
function putcsvAll($csv)	{
	global $csvname,$csvbakupname;

	$ret = true;
	//2016-11-11 ファイルロック処理追加
	$fh = fopen($csvname,'a');	//ロック用に仮オープン（追記モード）
	if (flock($fh, LOCK_EX)) {
//	if (false) {	//debug
		fclose($fh);	//いったんクローズ PHP5.3.2以降なら、ロック継続
		if(is_file($csvbakupname))	{
			$ret = unlink($csvbakupname);	//バックアップ削除
		}
		if($ret)	{
			rename($csvname,$csvbakupname);	//バックアップにリネーム
		}
	
		$fh = fopen($csvname,'wb');	//新規作成

		setlocale(LC_ALL, 'ja_JP.UTF-8');
		foreach ($csv as $fields) {
			_fputcsv($fh, $fields);
		}
		fflush($fh);
		flock($fh, LOCK_UN); 	//ロック解除
	} else {
		fclose($fh);	//
		errDsp("他に保存中の方が見つかりました。編集を中止します。");
	}
	fclose($fh);
}
/*
	csv１行書き込み
	文字列の所は、改行の無い項目も強制的に"で囲む
*/
function _fputcsv($fh,$line)	{
	$save = $line[POSTDATE].",";
	$save .= "\"".$line[SUBJECT]."\"".",";
	$save .= "\"".$line[TEXTBODY]."\"".",";
	$save .= "\"".$line[IMG_1]."\"".",";
	$save .= "\"".$line[IMG_2]."\"".",";
	$save .= "\"".$line[IMG_3]."\"".",";
	$save .= $line[DSP_FLG].",";
	$save .= "\"".$line[PDF_1]."\"";	//2014-08-19
	$save .= CRLF;
	fwrite($fh,$save);
}

/*
	画像保存
	日本語ファイル名が来ると動作不良の元になるので、ファイル名は日付時間から作る
*/
function imgUpload($imgid,$old,$imgtype)	{
	global $fiximgdir;

	$ext = pathinfo($_FILES[$imgid]['name'],PATHINFO_EXTENSION );

	$ext2 = strtolower($ext);
	if($ext2 == "pdf")	{
		if($imgtype == IMGPDF)	{
			//pdf処理
			//PDFはファイル名を保持する。（画面表示もする）
			//そのため、全角やスペースは禁止する。
			$orgfname = basename($_FILES[$imgid]['name']);
			$len1 = strlen($orgfname);
			$len2 = mb_strlen($orgfname,"UTF-8");
			if($len1 != $len2)	{
				return ERRPDF;
			}
			$fname = $orgfname;
		} else	{
			return "";
		}
	} else	{
		if($imgtype == IMGNOPDF)	{
			$fname = date( "YmdHis", time() ).$imgid.".".$ext;
		//	$fname = basename($_FILES[$imgid]['name']);	//元のファイル名を使いたい場合はこちら
		} else	{
			return "";
		}
	}

	$uploadfile = $fiximgdir . $fname;
	$ret = "";	//2014-02-17 Undefined variable: ret 対応
	if(is_uploaded_file($_FILES[$imgid]['tmp_name'])) {
		if(move_uploaded_file($_FILES[$imgid]['tmp_name'], $uploadfile)) {
			$ret = $fname;
		}
	}
	if(($ret != "") && ($old != ""))	{
		//旧ファイル削除
		if($ret != $old)	{	//通常は異なる。元のファイル名を使う場合は同一も起こり得る
			@unlink($fiximgdir.$old);
			//失敗しても報告しない。ゴミが残るのみ。
		}
	}
	return $ret;
}
?>
